'Class:     Image
'Author:    Todd Morrow
'Company:   Cosmologix
'Copyright: 1994-2010 Cosmologix
'Created:   10/25/2010 8:13:00 AM
'Purpose:   

Public Class Image

#Region "Constants"
#End Region

#Region "Enumerations"
  Public Enum SizeModes 'same values as picturebox size mode
    StretchImage = 1
    Zoom = 4
  End Enum
#End Region

#Region "Declares"
#End Region

#Region "Delegates"
#End Region

#Region "Structures"
#End Region

#Region "Events"
#End Region

#Region "Constructors"
#End Region

#Region "Properties"
#End Region

#Region "Methods"
#End Region

#Region "Event Handlers"
#End Region

#Region "Shared Properties"
#End Region

#Region "Shared Methods"
  Public Shared Function Transform(ByVal Image As System.Drawing.Image, ByVal Size As Size, Optional ByVal SizeMode As SizeModes = SizeModes.StretchImage, Optional ByVal TransparentArgb As Integer = Integer.MinValue, Optional ByVal BackColorArgb As Integer = Integer.MinValue) As System.Drawing.Image
    Transform = New System.Drawing.Bitmap(Size.Width, Size.Height)
    Dim Graphics As System.Drawing.Graphics = Graphics.FromImage(Transform)
    If BackColorArgb <> Integer.MinValue Then
      Graphics.Clear(Color.FromArgb(BackColorArgb))
    End If
    Select Case SizeMode
      Case SizeModes.StretchImage
        Graphics.DrawImage(Image, 0, 0, 32, 32)
      Case SizeModes.Zoom
        Dim Reduction As Single = Math.Min(CSng(Size.Height) / CSng(Image.Height), CSng(Size.Width) / CSng(Image.Width))
        Dim SizeF As New SizeF(CSng(Image.Width) * Reduction, CSng(Image.Height) * Reduction)
        Dim LocationF As New PointF(CSng(Size.Width) / 2.0 - SizeF.Width / 2.0, CSng(Size.Height) / 2.0 - SizeF.Height / 2.0)
        Graphics.DrawImage(Image, New RectangleF(LocationF, SizeF))
    End Select
    If TransparentArgb <> Integer.MinValue Then
      CType(Transform, System.Drawing.Bitmap).MakeTransparent(Color.FromArgb(TransparentArgb))
    End If
  End Function
#End Region

#Region "Operators"
#End Region

End Class
